/* Test of pow(). Invalid args.
 */

#include <math.h>
#include <stdlib.h>

static const struct {
    union {
	long lo;
        float fl;
    } x;
    union {
	long lo;
	float fl;
    } y;
} t[] = {

    /* Infinite x.	*/
    { { 0x7f800000 }, { .fl = 1 } },
    { { 0x7f800001 }, { .fl = 1 } },
    { { 0x7fc00000 }, { .fl = 1 } },
    { { 0x7fffffff }, { .fl = 1 } },
    { { 0xff800000 }, { .fl = 1 } },
    { { 0xff800001 }, { .fl = 1 } },
    { { 0xffc00000 }, { .fl = 1 } },
    { { 0xffffffff }, { .fl = 1 } },

    /* Infinite y.	*/
    { { .fl = 2 }, { 0x7f800000 } },
    { { .fl = 2 }, { 0x7f800001 } },
    { { .fl = 2 }, { 0x7fc00000 } },
    { { .fl = 2 }, { 0x7fffffff } },
#ifdef	__AVR__
    { { .fl = 2 }, { 0xff800000 } },		/* pow(2,-Inf) = 0	*/
#endif
    { { .fl = 2 }, { 0xff800001 } },
    { { .fl = 2 }, { 0xffc00000 } },
    { { .fl = 2 }, { 0xffffffff } },

    /* Infinite & zero.	*/
#ifdef	__AVR__
    { { 0x7fc00000 }, { 0x00000000 } },
    { { 0x7fc00000 }, { 0x80000000 } },
#endif
    { { 0x7fc00000 }, { 0x00000001 } },
    { { 0x7fc00000 }, { 0x80000001 } },
    { { 0x00000000 }, { 0x7fc00000 } },
    { { 0x80000000 }, { 0x7fc00000 } },
    { { 0x00000001 }, { 0x7fc00000 } },
    { { 0x80000001 }, { 0x7fc00000 } },

#ifdef	__AVR__
    /* pow (0,0)	*/
    { { 0 }, { 0 } },				/* Glibc: pow(0,0) = 1	*/
    { { 0 }, { 0x80000000 } },
    { { 0x80000000 }, { 0 } },
    { { 0x80000000 }, { 0x80000000 } },
#endif

    /* pow (0, negative_value)	*/
    { { 0 }, { 0x80000001 } },
    { { 0 }, { 0x80800000 } },
    { { 0 }, { 0xff000000 } },
    { { 0 }, { 0xff7fffff } },
    { { 0 }, { 0xff800000 } },
    { { 0 }, { 0xffffffff } },
    { { 0x80000000 }, { .fl = -1 } },

};

int main ()
{
    int i;
    float z;
    
    for (i = 0; i < (int)(sizeof(t) / sizeof(t[0])); i++) {
	z = pow (t[i].x.fl, t[i].y.fl);
	if (isfinite (z))
	    exit (i+1);
    }
    return 0;
}
