/* Test of pow(). Invalid combination: x < 0, y is not integer.
 */

#include <math.h>
#include <stdlib.h>

static const struct {
    union {
	long lo;
        float fl;
    } x;
    union {
	long lo;
	float fl;
    } y;
} t[] = {

    /* pow (negative, noninteger)	*/
    { { .fl = -1 }, { 0x00000001 } },
    { { .fl = -1 }, { 0x00000080 } },
    { { .fl = -1 }, { 0x00000100 } },
    { { .fl = -1 }, { 0x00008000 } },
    { { .fl = -1 }, { 0x00010000 } },
    { { .fl = -1 }, { 0x00800000 } },
    { { .fl = -1 }, { 0x00800001 } },
    { { .fl = -1 }, { 0x3e800000 } },		/* 0.25	*/
    { { .fl = -1 }, { 0x3f000000 } },		/* 0.5	*/
    { { .fl = -1 }, { 0x3f7fffff } },		/* 1.0 - delta	*/
    { { .fl = -1 }, { 0x3f800001 } },		/* 1.0 + delta	*/
    { { .fl = -1 }, { 0x3fffffff } },		/* 2.0 - delta	*/
    { { .fl = -1 }, { 0x40000001 } },		/* 2.0 + delta	*/
    { { .fl = -1 }, { 8388607.5 } },

    /* pow (negative, negative_noninteger)	*/
    { { .fl = -1 }, { 0x80000001 } },
    { { .fl = -1 }, { 0x80000200 } },
    { { .fl = -1 }, { 0x80004000 } },
    { { .fl = -1 }, { 0x80040000 } },
    { { .fl = -1 }, { 0x80800000 } },
    { { .fl = -1 }, { 0x80800001 } },
    { { .fl = -1 }, { 0xbe800000 } },		/* -0.25	*/
    { { .fl = -1 }, { 0xbf000000 } },		/* -0.5	*/
    { { .fl = -1 }, { 0xbf7fffff } },		/* -1.0 + delta	*/
    { { .fl = -1 }, { 0xbf800001 } },		/* -1.0 - delta	*/
    { { .fl = -1 }, { 0xbfffffff } },		/* -2.0 + delta	*/
    { { .fl = -1 }, { 0xc0000001 } },		/* -2.0 - delta	*/
    { { .fl = -1 }, { -8388607.5 } },
};


int main ()
{
    int i;
    float z;
    
    for (i = 0; i < (int)(sizeof(t) / sizeof(t[0])); i++) {
	z = pow (t[i].x.fl, t[i].y.fl);
	if (isfinite (z))
	    exit (i+1);
    }
    return 0;
}
