/* Test of pow(). Negative first argument and integer second.
 */

#include <math.h>
#include <stdlib.h>

static const struct {
    union {
	long lo;
        float fl;
    } x;
    union {
	long lo;
	float fl;
    } y;
    float z;
} t[] = {

    /* Negative x, zero y	*/
    { { 0x80000001}, { 0 }, 1 },
    { { 0x80800000}, { 0 }, 1 },
    { { .fl = -1 },  { 0 }, 1 },
    { { 0xff000000}, { 0 }, 1 },
    { { 0xff7fffff}, { 0 }, 1 },
    
    /* x == -1, positive y	*/
    { { .fl = -1 }, { .fl = 1 }, -1 },
    { { .fl = -1 }, { .fl = 2 },  1 },
    { { .fl = -1 }, { .fl = 3 }, -1 },
    { { .fl = -1 }, { .fl = 4 },  1 },
    { { .fl = -1 }, { .fl = 8388607 }, -1 },
    { { .fl = -1 }, { .fl = 8388608 },  1 },
    { { .fl = -1 }, { .fl = 16777215 }, -1 },
    { { .fl = -1 }, { .fl = 16777216 },  1 },
    { { .fl = -1 }, { .fl = 16777218 },  1 },
    { { .fl = -1 }, { 0x5e000000 }, 1 },
#ifdef	__AVR__
    { { .fl = -1 }, { 0x7f7fffff }, 1 },	/* Glibc: NaN ???	*/
#endif
    
    /* x == -1, negative y	*/
    { { .fl = -1 }, { .fl = -1 }, -1 },
    { { .fl = -1 }, { .fl = -2 },  1 },
    { { .fl = -1 }, { .fl = -3 }, -1 },
    { { .fl = -1 }, { .fl = -4 },  1 },
    { { .fl = -1 }, { .fl = -8388607 }, -1 },
    { { .fl = -1 }, { .fl = -8388608 },  1 },
    { { .fl = -1 }, { .fl = -16777215 }, -1 },
    { { .fl = -1 }, { .fl = -16777216 },  1 },
    { { .fl = -1 }, { .fl = -16777218 },  1 },
    { { .fl = -1 }, { 0xde000000 }, 1 },
#ifdef	__AVR__
    { { .fl = -1 }, { 0xff7fffff }, 1 },	/* Glibc: NaN ???	*/
#endif
};

int main ()
{
    int i;
    float z;
    
    for (i = 0; i < (int)(sizeof(t) / sizeof(t[0])); i++) {
	z = pow (t[i].x.fl, t[i].y.fl);
	if (z != t[i].z)
	    exit (i + 1);
    }
    return 0;
}
