/* Test of pow(). Small error is possible.
 */

#include <math.h>
#include <stdlib.h>

#define	EPS	1e-6	/* Possible relative error	*/

static const struct {
    float x, y, z;
} t[] = {

    { 2, 2, 4 },
    { 2, -2, 0.25 },

    { 10, -4, 1e-4 },
    { 10, +4, 1e+4 },
    { 1e-4, 1, 1e-4 },
    { 1e+4, 1, 1e+4 },
    { 1e-4, -1, 1e+4 },
    { 1e+4, -1, 1e-4 },

    { 100, -2, 1e-4 },
    { 100, +2, 1e+4 },
    
    { 0.1234,  5.6789,  6.913049e-06 },
    { 9.8765,  -4.321,  5.038719e-05 },
    
    { 3.4e38,  0,  1 },
    { 2e-38,   0,  1 },
};

int main ()
{
    int i;
    float z;
    
    for (i = 0; i < (int)(sizeof(t) / sizeof(t[0])); i++) {
	z = pow (t[i].x, t[i].y);
	if (fabs (z - t[i].z) > t[i].z * EPS)
	    exit (i + 1);
    }
    return 0;
}
